diff --git a/lib/hive/daemon/auto_retry/evidence.rb b/lib/hive/daemon/auto_retry/evidence.rb
new file mode 100644
index 00000000..f2ac1e1c
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/evidence.rb
@@ -0,0 +1,318 @@
+# frozen_string_literal: true
+
+require "yaml"
+require "hive/diagnostic_helpers"
+require "hive/diagnostic_evidence"
+require "hive/secret_patterns"
+require "hive/task_action"
+require "hive/markers"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Machine-oriented, fail-closed evidence loader for auto-retry
+      # classification. Reuses the containment/size/redaction discipline of
+      # DiagnosticEvidence and the marker_signature freshness gate shared
+      # with TaskAction diagnostics.
+      #
+      # Never raises to the daemon tick: every failure path returns a
+      # structured Hash with error/fresh flags so the classifier can emit
+      # a typed rejection rationale.
+      module Evidence
+        MAX_EVIDENCE_CHARS = 8_000
+        LOG_EPISODE_WINDOW_SEC = 5 * 60
+        EvidenceResult = Struct.new(
+          :text, :kind, :source_path, :fresh, :marker_signature_match, :error,
+          keyword_init: true
+        ) do
+          def to_h
+            {
+              text: text,
+              kind: kind,
+              source_path: source_path,
+              fresh: fresh,
+              marker_signature_match: marker_signature_match,
+              error: error
+            }
+          end
+        end
+
+        module_function
+
+        # @param folder [String] task folder
+        # @param state_file [String, nil] authoritative state file
+        # @param marker [Hive::Markers::Marker, Hash, nil] current marker
+        # @param marker_attrs [Hash, nil]
+        def load(folder:, state_file: nil, marker: nil, marker_attrs: nil)
+          root = folder.to_s
+          if root.strip.empty? || !File.directory?(root)
+            return failed(:missing_folder)
+          end
+
+          expected_sig = compute_signature(marker, marker_attrs)
+          marker_summary = marker_summary_text(marker, marker_attrs, state_file)
+
+          red = load_red_status(root, expected_sig, state_file)
+          return red if red
+
+          log = load_latest_log(
+            root,
+            marker_summary,
+            expected_sig: expected_sig,
+            marker_attrs: marker_attrs,
+            state_file: state_file
+          )
+          return log if log
+
+          if marker_summary && !marker_summary.empty?
+            return EvidenceResult.new(
+              text: bound(marker_summary),
+              kind: :marker,
+              source_path: state_file,
+              fresh: true,
+              marker_signature_match: true,
+              error: nil
+            )
+          end
+
+          failed(:missing_diagnostic)
+        rescue StandardError, SystemStackError, NoMemoryError => e
+          failed(:evidence_error, detail: "#{e.class}: #{e.message}")
+        end
+
+        def load_red_status(folder, expected_sig, state_file)
+          path = File.join(folder, "diagnostics", "red-status.md")
+          return nil unless File.file?(path)
+          return nil unless contained?(path, folder)
+
+          body = safe_read(path)
+          return failed(:unreadable_diagnostic) if body.nil?
+
+          frontmatter = parse_frontmatter(body)
+          sig = frontmatter["marker_signature"].to_s
+          sig_match = expected_sig.nil? || expected_sig.empty? || sig == expected_sig
+          return failed(:stale_diagnostic, kind: :red_status, source_path: path) unless sig_match
+
+          if state_file && File.file?(state_file)
+            art_mtime = Hive::DiagnosticHelpers.safe_mtime(path)
+            state_mtime = Hive::DiagnosticHelpers.safe_mtime(state_file)
+            if art_mtime && state_mtime && art_mtime < state_mtime
+              return failed(:stale_diagnostic, kind: :red_status, source_path: path)
+            end
+          end
+
+          text = frontmatter["summary"].to_s
+          text = body_first_line(body) if text.strip.empty?
+          text = body if text.strip.empty?
+          return nil if text.to_s.strip.empty?
+
+          EvidenceResult.new(
+            text: bound(text),
+            kind: :red_status,
+            source_path: path,
+            fresh: true,
+            marker_signature_match: true,
+            error: nil
+          )
+        end
+        private_class_method :load_red_status
+
+        def load_latest_log(folder, marker_summary, expected_sig:, marker_attrs:, state_file:)
+          candidates = log_candidates(folder)
+          candidates.each do |path|
+            next unless contained?(path, folder)
+            next unless current_log_episode?(
+              path,
+              expected_sig: expected_sig,
+              marker_attrs: marker_attrs,
+              state_file: state_file
+            )
+
+            excerpt = Hive::DiagnosticHelpers.tail_file(path)
+            next if excerpt.to_s.strip.empty?
+
+            parts = [ marker_summary, excerpt ].compact.reject { |p| p.to_s.strip.empty? }
+            text = parts.join(": ")
+            next if text.strip.empty?
+
+            return EvidenceResult.new(
+              text: bound(text),
+              kind: :log,
+              source_path: path,
+              fresh: true,
+              marker_signature_match: true,
+              error: nil
+            )
+          end
+          nil
+        end
+        private_class_method :load_latest_log
+
+        def current_log_episode?(path, expected_sig:, marker_attrs:, state_file:)
+          tail = Hive::DiagnosticHelpers.tail_file(path)
+          marker_id = (marker_attrs || {})["marker_id"] || (marker_attrs || {})[:marker_id]
+          return true if !marker_id.to_s.empty? && tail.include?(marker_id.to_s)
+          return true if !expected_sig.to_s.empty? && tail.include?(expected_sig.to_s)
+
+          return false unless state_file && File.file?(state_file)
+
+          log_mtime = Hive::DiagnosticHelpers.safe_mtime(path)
+          state_mtime = Hive::DiagnosticHelpers.safe_mtime(state_file)
+          return false unless log_mtime && state_mtime
+
+          (state_mtime - log_mtime).abs <= LOG_EPISODE_WINDOW_SEC
+        rescue SystemCallError, IOError
+          false
+        end
+        private_class_method :current_log_episode?
+
+        def log_candidates(folder)
+          dirs = [
+            File.join(folder, "logs"),
+            inferred_log_dir(folder)
+          ].compact.uniq
+          candidates = dirs.flat_map { |dir| Dir[File.join(dir, "*.log")] }
+          candidates.sort_by { |p| Hive::DiagnosticHelpers.safe_mtime(p) || Time.at(0) }
+                    .last(Hive::DiagnosticHelpers::LOG_GLOB_CAP)
+                    .reverse
+        rescue SystemCallError
+          []
+        end
+        private_class_method :log_candidates
+
+        def inferred_log_dir(folder)
+          require "hive/task"
+          match = Hive::Task::PATH_RE.match(folder.to_s)
+          return nil unless match
+
+          File.join(match[:root], match[:state_dir], "logs", match[:slug])
+        rescue LoadError, StandardError
+          nil
+        end
+        private_class_method :inferred_log_dir
+
+        def contained?(path, folder)
+          real = File.realpath(path)
+          return false unless File.file?(real)
+
+          roots = [
+            Hive::DiagnosticHelpers.evidence_root_realpath(folder, trust_anchor: true),
+            Hive::DiagnosticHelpers.evidence_root_realpath(File.join(folder, "logs"), trust_anchor: false),
+            Hive::DiagnosticHelpers.evidence_root_realpath(inferred_log_dir(folder), trust_anchor: false)
+          ].compact
+          roots.any? { |root| Hive::DiagnosticHelpers.path_inside?(real, root) }
+        rescue SystemCallError
+          false
+        end
+        private_class_method :contained?
+
+        def safe_read(path)
+          raw = File.open(path, "rb") do |f|
+            f.read(Hive::DiagnosticHelpers::FRONTMATTER_SCAN_BYTES + MAX_EVIDENCE_CHARS).to_s
+          end
+          Hive::DiagnosticHelpers.utf8(raw)
+        rescue SystemCallError, IOError
+          nil
+        end
+        private_class_method :safe_read
+
+        def parse_frontmatter(body)
+          match = body.match(/\A---\n(.*?)\n---\n/m)
+          return {} unless match
+
+          parsed = YAML.safe_load(match[1], permitted_classes: [ Time ]) || {}
+          return {} unless parsed.is_a?(Hash)
+
+          parsed.transform_keys(&:to_s)
+        rescue Psych::Exception, SystemStackError, NoMemoryError
+          {}
+        end
+        private_class_method :parse_frontmatter
+
+        def body_first_line(body)
+          in_frontmatter = false
+          body.each_line do |line|
+            stripped = line.strip
+            if stripped == "---"
+              in_frontmatter = !in_frontmatter
+              next
+            end
+            next if in_frontmatter || stripped.empty?
+
+            return stripped
+          end
+          ""
+        end
+        private_class_method :body_first_line
+
+        def compute_signature(marker, marker_attrs)
+          if marker.respond_to?(:name) && marker.respond_to?(:attrs)
+            return Hive::TaskAction.marker_signature(marker)
+          end
+
+          attrs = marker_attrs
+          attrs = marker[:attrs] || marker["attrs"] if marker.is_a?(Hash) && attrs.nil?
+          name = if marker.is_a?(Hash)
+            marker[:name] || marker["name"] || :error
+          elsif marker.respond_to?(:name)
+            marker.name
+          else
+            :error
+          end
+          fake = Struct.new(:name, :attrs).new(name, attrs || {})
+          Hive::TaskAction.marker_signature(fake)
+        rescue StandardError
+          nil
+        end
+        private_class_method :compute_signature
+
+        def marker_summary_text(marker, marker_attrs, state_file)
+          if marker.respond_to?(:name) && !marker.respond_to?(:none?)
+            return Hive::Markers.summary(marker)
+          end
+          if marker.respond_to?(:none?) && !marker.none?
+            return Hive::Markers.summary(marker)
+          end
+
+          if state_file && File.file?(state_file)
+            current = Hive::Markers.current(state_file)
+            return Hive::Markers.summary(current) unless current.none?
+          end
+
+          attrs = marker_attrs || {}
+          reason = attrs["reason"] || attrs[:reason]
+          message = attrs["message"] || attrs[:message]
+          return nil if reason.nil? && (message.nil? || message.to_s.empty?)
+
+          parts = [ "ERROR" ]
+          parts << "reason=#{reason}" if reason
+          parts << message.to_s if message && !message.to_s.empty?
+          parts.join(" ")
+        rescue StandardError
+          nil
+        end
+        private_class_method :marker_summary_text
+
+        def bound(text)
+          redacted = Hive::SecretPatterns.redact(
+            Hive::DiagnosticHelpers.utf8(text.to_s).gsub(/\s+/, " ").strip
+          )
+          Hive::DiagnosticHelpers.truncate(redacted, MAX_EVIDENCE_CHARS)
+        end
+        private_class_method :bound
+
+        def failed(error, kind: nil, source_path: nil, detail: nil)
+          EvidenceResult.new(
+            text: detail,
+            kind: kind,
+            source_path: source_path,
+            fresh: error != :stale_diagnostic,
+            marker_signature_match: error != :stale_diagnostic,
+            error: error
+          )
+        end
+        private_class_method :failed
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/auto_retry/health.rb b/lib/hive/daemon/auto_retry/health.rb
new file mode 100644
index 00000000..c6939dea
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/health.rb
@@ -0,0 +1,524 @@
+# frozen_string_literal: true
+
+require "digest"
+require "json"
+require "stringio"
+require "tmpdir"
+require "fileutils"
+require "hive/runtime_identity"
+require "hive/daemon/auto_retry/probe_runner"
+require "hive/stages/base"
+require "hive/config"
+require "hive/claude_launcher"
+require "hive/commands/doctor"
+require "hive/secret_patterns"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Reason-specific health probes and canonical health fingerprints for
+      # auto-retry. Fail-closed: any timeout, nonzero exit, parse failure,
+      # missing binary, or identity mismatch is unhealthy.
+      class Health
+        STATUS_TIMEOUT = ProbeRunner::DEFAULT_STATUS_TIMEOUT_SEC
+        SMOKE_TIMEOUT = ProbeRunner::DEFAULT_SMOKE_TIMEOUT_SEC
+
+        ProbeSetResult = Struct.new(
+          :healthy, :fingerprint, :probes, :rationale, :correlation_id,
+          keyword_init: true
+        )
+
+        def initialize(runner: nil, env: nil, clock: -> { Time.now })
+          @runner = runner || ProbeRunner.new(env: scrubbed_env(env))
+          @env = env
+          @clock = clock
+          @cache = {}
+        end
+
+        # Reset per-tick cache (call at start of each daemon tick).
+        def reset_tick_cache!
+          @cache = {}
+        end
+
+        def probe(recovery_class:, config:, project_root: nil, stage: nil)
+          key = cache_key(recovery_class, config, project_root, stage)
+          return @cache[key] if @cache.key?(key)
+
+          result = case recovery_class.to_sym
+          when :codex_auth_401
+            probe_codex(config, project_root: project_root)
+          when :claude_launcher
+            probe_claude(config, project_root: project_root, stage: stage)
+          else
+            ProbeSetResult.new(
+              healthy: false, fingerprint: nil, probes: [],
+              rationale: "unknown_recovery_class",
+              correlation_id: correlation_id
+            )
+          end
+          @cache[key] = result
+          result
+        end
+
+        def cached?(recovery_class:, config:, project_root: nil, stage: nil)
+          @cache.key?(cache_key(recovery_class, config, project_root, stage))
+        end
+
+        # Cheap, non-secret signal used to decide whether an unhealthy probe
+        # should run before the 30-minute fallback cadence. No subprocesses.
+        def signal_fingerprint(recovery_class:, config:, project_root: nil, stage: nil)
+          profile = profile_for(recovery_class, config, stage)
+          payload = {
+            "recovery_class" => recovery_class.to_s,
+            "runtime" => Hive::RuntimeIdentity.snapshot,
+            "config" => relevant_config_subset(config),
+            "project_root" => project_root.to_s,
+            "stage" => stage.to_s,
+            "agent_bin" => file_metadata(resolve_executable(profile&.bin)),
+            "wrapper" => file_metadata(claude_wrapper_path),
+            "credentials" => credential_metadata(recovery_class)
+          }
+          ::Digest::SHA256.hexdigest(JSON.generate(sort_keys(payload)))
+        rescue StandardError
+          nil
+        end
+
+        def probe_codex(config, project_root: nil)
+          cid = correlation_id
+          probes = []
+          profile = safe_profile(config, "execute")
+          bin = profile&.bin || "codex"
+
+          doctor = required_doctor_green?(config, project_root)
+          probes << { "name" => "doctor_required", "ok" => doctor[:ok],
+                      "detail" => doctor[:detail] }
+          return unhealthy(probes, cid, "doctor_unhealthy", config, profile) unless doctor[:ok]
+
+          login = @runner.run([ bin, "login", "status" ], timeout_sec: STATUS_TIMEOUT)
+          probes << probe_entry("codex_login_status", login)
+          unless login.healthy?
+            return unhealthy(probes, cid, "codex_login_unhealthy", config, profile)
+          end
+
+          smoke = run_codex_smoke(profile || safe_profile({}, "execute"), bin)
+          completion_ok = smoke.healthy? && codex_completion_record?(smoke.stdout)
+          smoke_entry = probe_entry("codex_exec_smoke", smoke)
+          smoke_entry["completion_record"] = completion_ok
+          probes << smoke_entry
+          unless smoke.healthy?
+            return unhealthy(probes, cid, "codex_smoke_unhealthy", config, profile)
+          end
+          unless completion_ok
+            return unhealthy(probes, cid, "codex_smoke_malformed", config, profile)
+          end
+
+          fp = fingerprint(
+            recovery_class: :codex_auth_401,
+            config: config,
+            profile: profile,
+            extra: {
+              "login_ok" => true,
+              "smoke_ok" => true,
+              "doctor" => doctor_inventory(doctor)
+            }
+          )
+          ProbeSetResult.new(healthy: true, fingerprint: fp, probes: probes,
+                             rationale: "healthy", correlation_id: cid)
+        end
+
+        def probe_claude(config, project_root: nil, stage: nil)
+          cid = correlation_id
+          probes = []
+          profile = profile_for(:claude_launcher, config, stage)
+          failures = []
+
+          wrapper = claude_wrapper_path
+          wrapper_ok = wrapper && File.file?(wrapper) && File.executable?(wrapper)
+          probes << {
+            "name" => "claude_wrapper",
+            "ok" => wrapper_ok == true,
+            "detail" => wrapper_ok ? "present" : "missing_or_not_executable"
+          }
+          failures << "wrapper_unhealthy" unless wrapper_ok
+
+          readiness = readiness_self_check
+          probes << { "name" => "readiness_detector", "ok" => readiness[:ok],
+                      "detail" => readiness[:detail] }
+          failures << "readiness_unhealthy" unless readiness[:ok]
+
+          tmux_probe, tmux_row = bounded_tmux_row
+          tmux_ok = tmux_row[:status].to_s == "present"
+          probes << probe_entry("tmux", tmux_probe).merge("detail" => tmux_row[:message])
+          failures << "tmux_unhealthy" unless tmux_ok
+
+          version = agent_version(profile)
+          probes << version[:entry]
+          failures << "claude_runtime_unhealthy" unless version[:ok]
+
+          doctor = required_doctor_green?(config, project_root, dependency_rows: [ tmux_row ])
+          probes << { "name" => "doctor_required", "ok" => doctor[:ok],
+                      "detail" => doctor[:detail] }
+          failures << "doctor_unhealthy" unless doctor[:ok]
+
+          identity = identity_matches?
+          probes << { "name" => "runtime_identity", "ok" => identity[:ok],
+                      "detail" => identity[:detail] }
+          failures << "identity_mismatch" unless identity[:ok]
+
+          if failures.any?
+            return ProbeSetResult.new(
+              healthy: false, fingerprint: nil, probes: probes,
+              rationale: failures.first, correlation_id: cid
+            )
+          end
+
+          fp = fingerprint(
+            recovery_class: :claude_launcher,
+            config: config,
+            profile: profile,
+            extra: {
+              "wrapper_digest" => file_digest(wrapper),
+              "wrapper_mtime" => safe_mtime_i(wrapper),
+              "readiness" => readiness[:detail],
+              "tmux" => tmux_row[:message].to_s,
+              "claude_version" => version[:version],
+              "doctor" => "green",
+              "identity" => Hive::RuntimeIdentity.snapshot
+            }
+          )
+          ProbeSetResult.new(healthy: true, fingerprint: fp, probes: probes,
+                             rationale: "healthy", correlation_id: cid)
+        end
+
+        # Lightweight in-process Doctor view: only required agent skill /
+        # dependency rows. Optional warnings (qmd, legacy runtime) do not fail.
+        def self.required_agent_report(config:, project_root: nil, dependency_rows: nil)
+          required = Hive::Commands::Doctor.required_agent_rows(
+            config: config,
+            project_root: project_root,
+            dependency_rows: dependency_rows
+          )
+          failing = Array(required).select do |r|
+            status = (r[:status] || r["status"]).to_s
+            %w[missing version_too_old].include?(status)
+          end
+          {
+            ok: failing.empty?,
+            rows: required,
+            failing: failing,
+            detail: failing.empty? ? "green" : failing.map { |r| r[:label] || r["label"] }.join(",")
+          }
+        rescue StandardError => e
+          { ok: false, rows: [], failing: [], detail: "#{e.class}: #{e.message}" }
+        end
+
+        def fingerprint(recovery_class:, config:, profile: nil, extra: {})
+          payload = {
+            "recovery_class" => recovery_class.to_s,
+            "version" => Hive::RuntimeIdentity.version,
+            "code_fingerprint" => Hive::RuntimeIdentity.code_fingerprint,
+            "binary_path" => Hive::RuntimeIdentity.binary_path,
+            "agent" => profile&.name.to_s,
+            "agent_bin" => profile&.bin.to_s,
+            "agent_binary" => file_metadata(resolve_executable(profile&.bin)),
+            "credentials" => credential_metadata(recovery_class),
+            "config" => relevant_config_subset(config),
+            "extra" => stringify_keys(extra)
+          }
+          canonical = JSON.generate(sort_keys(payload))
+          # Ensure secrets never enter the fingerprint source.
+          redacted = Hive::SecretPatterns.redact(canonical)
+          ::Digest::SHA256.hexdigest(redacted)
+        end
+
+        private
+
+        def run_codex_smoke(profile, bin)
+          Dir.mktmpdir("hive-codex-smoke-") do |dir|
+            # Tiny isolated exec; never the task worktree.
+            prompt = "Reply with exactly: ok"
+            argv = [ bin, profile&.headless_flag || "exec" ]
+            argv.concat(profile&.output_format_flags || [ "--json" ])
+            argv.concat([ "--skip-git-repo-check", "-" ])
+            @runner.run(
+              argv,
+              timeout_sec: SMOKE_TIMEOUT,
+              chdir: dir,
+              stdin_data: "#{prompt}\n"
+            )
+          end
+        end
+
+        def codex_completion_record?(stdout)
+          stdout.to_s.each_line.any? do |line|
+            event = JSON.parse(line)
+            %w[turn.completed response.completed result].include?(event["type"].to_s) &&
+              !%w[failed error cancelled].include?((event["status"] || event.dig("turn", "status")).to_s)
+          rescue JSON::ParserError
+            false
+          end
+        end
+
+        def claude_wrapper_path
+          Hive::ClaudeLauncher.interactive_wrapper_path
+        end
+
+        def readiness_self_check
+          Hive::ClaudeLauncher.readiness_detector_self_check
+        end
+
+        def required_doctor_green?(config, project_root, dependency_rows: nil)
+          rows = dependency_rows
+          if rows.nil? && Hive::Config.claude_mode(config) == :tmux
+            _probe, row = bounded_tmux_row
+            rows = [ row ]
+          end
+          self.class.required_agent_report(
+            config: config,
+            project_root: project_root,
+            dependency_rows: rows
+          )
+        end
+
+        def identity_matches?
+          snap = Hive::RuntimeIdentity.snapshot
+          if snap["code_fingerprint"].nil?
+            return { ok: false, detail: "no_code_fingerprint" }
+          end
+
+          hive_bin = Hive::RuntimeIdentity.binary_path
+          return { ok: false, detail: "no_binary_path" } if hive_bin.to_s.empty?
+
+          result = @runner.run([ hive_bin, "version", "--json" ], timeout_sec: STATUS_TIMEOUT)
+          unless result.healthy?
+            return { ok: false, detail: "cli_probe_failed" }
+          end
+
+          parsed = JSON.parse(result.stdout)
+          return { ok: false, detail: "cli_identity_not_object" } unless parsed.is_a?(Hash)
+
+          cli_version = parsed["version"]
+          cli_fp = parsed["code_fingerprint"]
+          cli_bin = parsed["binary_path"]
+          if [ cli_version, cli_fp, cli_bin ].any? { |value| value.to_s.empty? }
+            return { ok: false, detail: "cli_identity_incomplete" }
+          end
+          ok = Hive::RuntimeIdentity.matches_cli?(
+            cli_version: cli_version,
+            cli_fingerprint: cli_fp,
+            cli_binary_path: cli_bin
+          )
+          { ok: ok, detail: ok ? "match" : "mismatch" }
+        rescue StandardError => e
+          { ok: false, detail: e.class.name }
+        end
+
+        def bounded_tmux_row
+          bin = Hive::ClaudeLauncher.tmux_bin
+          result = @runner.run([ bin, "-V" ], timeout_sec: STATUS_TIMEOUT)
+          status = "missing"
+          message = result.error.to_s
+          if result.healthy?
+            version = Hive::ClaudeLauncher.parse_tmux_version(result.stdout)
+            if version.nil?
+              message = "could not parse tmux -V output"
+            elsif (Hive::ClaudeLauncher.version_tuple(version) <=>
+                   Hive::ClaudeLauncher.version_tuple(Hive::ClaudeLauncher::MIN_TMUX_VERSION)).negative?
+              status = "version_too_old"
+              message = "tmux #{version} below minimum #{Hive::ClaudeLauncher::MIN_TMUX_VERSION}"
+            else
+              status = "present"
+              message = "tmux #{version} found"
+            end
+          end
+          row = {
+            kind: "dependency", stage: "claude", label: "claude/tmux",
+            agent: "tmux", configured_skill: "tmux >= #{Hive::ClaudeLauncher::MIN_TMUX_VERSION}",
+            skill: "tmux", status: status, message: message
+          }
+          [ result, row ]
+        end
+
+        def agent_version(profile)
+          unless profile
+            return { ok: false, version: nil,
+                     entry: { "name" => "claude_version", "ok" => false,
+                              "detail" => "profile_missing" } }
+          end
+          result = @runner.run([ profile.bin, profile.version_flag ], timeout_sec: STATUS_TIMEOUT)
+          version = result.stdout.to_s[/\d+\.\d+\.\d+/]
+          ok = result.healthy? && !version.nil?
+          if ok && profile.min_version
+            ok = (version.split(".").map(&:to_i) <=>
+                  profile.min_version.split(".").map(&:to_i)) >= 0
+          end
+          entry = probe_entry("claude_version", result)
+          entry["version"] = version
+          entry["ok"] = ok
+          { ok: ok, version: version, entry: entry }
+        end
+
+        def doctor_inventory(report)
+          Array(report[:rows]).map do |row|
+            {
+              "label" => row[:label] || row["label"],
+              "status" => row[:status] || row["status"]
+            }
+          end
+        end
+
+        def profile_for(recovery_class, config, stage)
+          if recovery_class.to_sym == :codex_auth_401
+            safe_profile(config, "execute")
+          else
+            safe_profile(config, stage_role(stage)) || safe_profile(config, "plan") || safe_profile(config, "execute")
+          end
+        end
+
+        def stage_role(stage)
+          stage.to_s.sub(/\A\d+-/, "").tr("-", "_")
+        end
+
+        def resolve_executable(bin)
+          return nil if bin.to_s.empty?
+          return File.expand_path(bin) if bin.to_s.include?(File::SEPARATOR)
+
+          ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+            path = File.join(dir, bin.to_s)
+            return path if File.file?(path) && File.executable?(path)
+          end
+          nil
+        end
+
+        def file_metadata(path)
+          return nil unless path && File.file?(path)
+
+          stat = File.stat(path)
+          { "path" => File.realpath(path), "size" => stat.size, "mtime" => stat.mtime.to_i }
+        rescue StandardError
+          nil
+        end
+
+        def credential_metadata(recovery_class)
+          paths = if recovery_class.to_sym == :codex_auth_401
+            [ File.expand_path("~/.codex/auth.json") ]
+          else
+            [ File.expand_path("~/.claude.json"), File.expand_path("~/.claude/.credentials.json") ]
+          end
+          paths.filter_map { |path| file_metadata(path) }
+        rescue StandardError
+          []
+        end
+
+        def relevant_config_subset(config)
+          return {} unless config.is_a?(Hash)
+
+          {
+            "execute.agent" => config.dig("execute", "agent"),
+            "brainstorm.agent" => config.dig("brainstorm", "agent"),
+            "plan.agent" => config.dig("plan", "agent"),
+            "claude.mode" => config.dig("claude", "mode"),
+            "agents.codex.bin" => config.dig("agents", "codex", "bin"),
+            "agents.claude.bin" => config.dig("agents", "claude", "bin")
+          }.compact
+        end
+
+        def safe_profile(config, stage)
+          Hive::Stages::Base.stage_profile(config, stage)
+        rescue StandardError
+          nil
+        end
+
+        def probe_entry(name, result)
+          {
+            "name" => name,
+            "ok" => result.healthy?,
+            "timed_out" => result.timed_out,
+            "exit_status" => result.exit_status,
+            "duration_sec" => result.duration_sec,
+            "error" => result.error,
+            "stdout" => truncate(result.stdout, 400),
+            "stderr" => truncate(result.stderr, 400)
+          }
+        end
+
+        def unhealthy(probes, cid, rationale, config, profile)
+          ProbeSetResult.new(
+            healthy: false,
+            fingerprint: nil,
+            probes: probes,
+            rationale: rationale,
+            correlation_id: cid
+          )
+        end
+
+        def truncate(text, max)
+          s = text.to_s
+          s.bytesize <= max ? s : s.byteslice(0, max).to_s.scrub + "…"
+        end
+
+        def file_digest(path)
+          return nil unless path && File.file?(path)
+
+          ::Digest::SHA256.file(path).hexdigest
+        rescue StandardError
+          nil
+        end
+
+        def safe_mtime_i(path)
+          File.mtime(path).to_i
+        rescue StandardError
+          nil
+        end
+
+        def correlation_id
+          ::Digest::SHA256.hexdigest("#{@clock.call.to_f}-#{object_id}")[0, 12]
+        end
+
+        def cache_key(recovery_class, config, project_root, stage = nil)
+          [
+            recovery_class.to_s,
+            relevant_config_subset(config).inspect,
+            project_root.to_s,
+            stage.to_s
+          ].join("|")
+        end
+
+        def scrubbed_env(env)
+          base = (env || ENV).to_h
+          # Drop known secret-bearing keys from child environment copies used
+          # only for probes; keep PATH/HOME/USER and agent auth files intact
+          # via the normal process environment when env is nil.
+          return nil if env.nil?
+
+          base.reject { |k, _| k.to_s.match?(/TOKEN|SECRET|PASSWORD|API_KEY|CREDENTIAL/i) }
+        end
+
+        def sort_keys(obj)
+          case obj
+          when Hash
+            obj.keys.map(&:to_s).sort.each_with_object({}) do |k, acc|
+              value = obj.key?(k) ? obj[k] : obj[k.to_sym]
+              acc[k] = sort_keys(value)
+            end
+          when Array
+            obj.map { |v| sort_keys(v) }
+          else
+            obj
+          end
+        end
+
+        def stringify_keys(obj)
+          case obj
+          when Hash
+            obj.each_with_object({}) { |(k, v), acc| acc[k.to_s] = stringify_keys(v) }
+          when Array
+            obj.map { |v| stringify_keys(v) }
+          else
+            obj
+          end
+        end
+      end
+    end
+  end
+end
